unit FShFolderDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShFolder, ExtCtrls;

type
  TForm1 = class(TForm)
    FoldersComboBox: TComboBox;
    ResultLabel: TLabel;
    FolderPathLabel: TLabel;
    Button1: TButton;
    Bevel1: TBevel;
    InfoLabel: TLabel;
    procedure FoldersComboBoxChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure SetPathLabel;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.SetPathLabel;
const
  CSIDLs: array[-1..14] of Integer = (0,
    CSIDL_PERSONAL, CSIDL_APPDATA, CSIDL_LOCAL_APPDATA, CSIDL_INTERNET_CACHE,
    CSIDL_COOKIES, CSIDL_HISTORY, CSIDL_COMMON_APPDATA, CSIDL_WINDOWS,
    CSIDL_SYSTEM, CSIDL_PROGRAM_FILES, CSIDL_MYPICTURES,
    CSIDL_PROGRAM_FILES_COMMON, CSIDL_COMMON_DOCUMENTS,
    CSIDL_COMMON_ADMINTOOLS, CSIDL_ADMINTOOLS);
var
  Path: array[0..MAX_PATH] of Char;
begin
  if Succeeded(SHGetFolderPath(Handle, CSIDLs[FoldersComboBox.ItemIndex], 0,
                 SHGFP_TYPE_CURRENT, Path)) and
     (StrLen(Path) <> 0) then
    ResultLabel.Caption := Path
  else
    ResultLabel.Caption := 'Path not available on this system';
end;

procedure TForm1.FoldersComboBoxChange(Sender: TObject);
begin
  SetPathLabel;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

end.
